Index: /anuga_work/production/broome_2006/export_results.py
===================================================================
--- /anuga_work/production/broome_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/broome_2006/export_results.py	(revision 4347)
@@ -26,5 +26,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/dampier_2006/export_results.py
===================================================================
--- /anuga_work/production/dampier_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/dampier_2006/export_results.py	(revision 4347)
@@ -29,6 +29,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed_i0'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/hobart_2006/export_results.py
===================================================================
--- /anuga_work/production/hobart_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/hobart_2006/export_results.py	(revision 4347)
@@ -29,5 +29,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed'
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/newcastle_2006/export_results.py
===================================================================
--- /anuga_work/production/newcastle_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/newcastle_2006/export_results.py	(revision 4347)
@@ -66,6 +66,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed_i0'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/onslow_2006/export_results.py
===================================================================
--- /anuga_work/production/onslow_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/onslow_2006/export_results.py	(revision 4347)
@@ -31,5 +31,5 @@
 #print 'Which variable do you want to export?'
 #which_var = int(raw_input('Stage = 0, Absolute Momentum = 1, Depth = 2, Speed = 3  '  ))
-which_var = 4
+which_var = 3
 #sys.stderr.write(sys.stdout.data)
 if which_var == 0:  # Stage
@@ -47,7 +47,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    #quantityname = 'xmomentum/(stage-elevation)'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
@@ -61,8 +59,8 @@
             cellsize = 25,       
             # define region for viz purposes
-            #easting_min = project.e_min_area,
-            #easting_max = project.e_max_area,
-            #northing_min = project.n_min_area,
-            #northing_max = project.n_max_area,        
+            easting_min = project.e_min_area,
+            easting_max = project.e_max_area,
+            northing_min = project.n_min_area,
+            northing_max = project.n_max_area,        
             reduction = max, #this is because we want max quantityname
             verbose = True,
Index: /anuga_work/production/pt_hedland_2006/export_results.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/pt_hedland_2006/export_results.py	(revision 4347)
@@ -44,7 +44,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    #quantityname = 'xmomentum/(stage-elevation)'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/sydney_2006/export_results.py
===================================================================
--- /anuga_work/production/sydney_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/sydney_2006/export_results.py	(revision 4347)
@@ -40,6 +40,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed_i0'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation
Index: /anuga_work/production/wollongong_2006/export_results.py
===================================================================
--- /anuga_work/production/wollongong_2006/export_results.py	(revision 4346)
+++ /anuga_work/production/wollongong_2006/export_results.py	(revision 4347)
@@ -49,6 +49,5 @@
 if which_var == 3:  # Speed
     outname = name + '_speed_i0'
-    #quantityname = '((xmomentum/(stage-elevation))**2 + (ymomentum/(stage-elevation))**2)**0.5'  #Speed
-    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-30)'  #Speed
+    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
 
 if which_var == 4:  # Elevation