Index: /anuga_core/source/anuga/shallow_water/test_data_manager.py
===================================================================
--- /anuga_core/source/anuga/shallow_water/test_data_manager.py	(revision 4413)
+++ /anuga_core/source/anuga/shallow_water/test_data_manager.py	(revision 4414)
@@ -25,8 +25,16 @@
 
 class Test_Data_Manager(unittest.TestCase):
+    # Class variable
+    verbose = False
+
+    def set_verbose(self):
+        Test_Data_Manager.verbose = True
+        
     def setUp(self):
         import time
         from mesh_factory import rectangular
 
+        
+        self.verbose = Test_Data_Manager.verbose
         #Create basic mesh
         points, vertices, boundary = rectangular(2, 2)
@@ -1128,5 +1136,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
-                verbose = False,
+                verbose = self.verbose,
                 format = 'asc')
 
@@ -5977,7 +5985,21 @@
     #suite = unittest.makeSuite(Test_Data_Manager,'cache_test_URS_points_needed_and_urs_ungridded2sww')
     #suite = unittest.makeSuite(Test_Data_Manager,'test_urs_ungridded_hole')
+    if len(sys.argv) > 1 and sys.argv[1][0].upper() == 'V':
+        Test_Data_Manager.verbose=True
+        saveout = sys.stdout   
+        filename = ".temp_verbose"
+        fid = open(filename, 'w')
+        sys.stdout = fid
+    else:
+        pass
     suite = unittest.makeSuite(Test_Data_Manager,'test')
     runner = unittest.TextTestRunner() #verbosity=2)
     runner.run(suite)
 
-
+    # Cleaning up
+    if len(sys.argv) > 1 and sys.argv[1][0].upper() == 'V':
+        sys.stdout = saveout 
+        #fid.close() # This was causing an error in windows
+        #os.remove(filename)
+
+
Index: /anuga_core/source/anuga/test_all.py
===================================================================
--- /anuga_core/source/anuga/test_all.py	(revision 4413)
+++ /anuga_core/source/anuga/test_all.py	(revision 4414)
@@ -12,4 +12,5 @@
 import os
 import sys
+import tempfile
 
 
@@ -65,5 +66,5 @@
 
 
-def regressionTest():
+def regressionTest(test_verbose=False):
     path = os.getcwd()
     test_files, path_files = get_test_files(path)
@@ -87,17 +88,78 @@
     moduleNames = map(filenameToModuleName, files)
     modules = map(__import__, moduleNames)
-
     # Fix up the system path
     for file in path_files:
         sys.path.remove(file)
-        
     load = unittest.defaultTestLoader.loadTestsFromModule
-    return unittest.TestSuite(map(load, modules))
+    testCaseClasses = map(load, modules)
+    if test_verbose is True:
+        print "moduleNames", moduleNames 
+        print "modules", modules
+        print "load", load
+        #print "weak", testCaseClasses.countTestCases()
+        #sys.exit()
+        i=0
+        from anuga.shallow_water.test_data_manager import Test_Data_Manager
+        from anuga.geospatial_data.test_geospatial_data import Test_Geospatial_data
+        #print "test_data_manager.Test_Data_Manager", type(Test_Data_Manager)
+        for test_suite in testCaseClasses:
+            i += 1
+            print "counting ", i
+            #testCaseClass.classVerbose = True
+            #testCaseClass.Verbose = True
+            #print "testCaseClass",testCaseClass
+            #print "testCaseClass",type(tests)
+            #print "weak", tests.countTestCases()
+            #print "weak", tests.__weakref__
+            #print "dic",  tests.__dict__
+            #print "testCaseClass.tests",  testCaseClass._tests[0]._tests[0].yah()
+            for tests in test_suite._tests:
+                #tests is of class TestSuite
+                print "tests weak", tests.__weakref__
+                if len(tests._tests) >1:
+                    # these are the test functions
+                    print "tests._tests[0]", tests._tests[0]
+                    print "tests._tests[0]", tests._tests[0].__dict__
+                    #print "tests._tests[0]", tests._tests[0].__name__
+                    try:
+                        # Calls set_verbose in the test case classes
+                        tests._tests[0].set_verbose()
+                    except:
+                        pass # No all classes have
+                    tests._tests[0].verbose=True # A call methods
+                    if type(tests._tests[0]) == type(Test_Data_Manager):
+                        print "testCaseClass is the class Test_Data_Manager"
+                        sys.exit()
+                
+                    if type(tests._tests[0]) == type(Test_Geospatial_data):
+                        print "testCaseClass is the class Test_Data_Manager"
+                        sys.exit()
+            if isinstance(tests, Test_Data_Manager):
+                print "testCaseClass is an instance of Test_Data_Manager"
+                sys.exit()
+            if type(tests) == type(Test_Data_Manager):
+                print "testCaseClass is the class Test_Data_Manager"
+                sys.exit()
+            
+        #sys.exit()   
+    return unittest.TestSuite(testCaseClasses)
 
 if __name__ == '__main__':
-    #unittest.main(defaultTest='regressionTest')
-
-    suite = regressionTest()
+    if len(sys.argv) > 1 and sys.argv[1][0].upper() == 'V':
+        test_verbose = True
+        saveout = sys.stdout   
+        filename = ".temp"
+        fid = open(filename, 'w')
+        sys.stdout = fid
+    else:
+        test_verbose = False        
+    suite = regressionTest(test_verbose)
     runner = unittest.TextTestRunner() #verbosity=2
     runner.run(suite)
     
+    # Cleaning up
+    if len(sys.argv) > 1 and sys.argv[1][0].upper() == 'V':
+        sys.stdout = saveout 
+        #fid.close() # This was causing an error in windows
+        #os.remove(filename)
+