Index: /anuga_work/production/broome_2006/project_urs.py
===================================================================
--- /anuga_work/production/broome_2006/project_urs.py	(revision 4431)
+++ /anuga_work/production/broome_2006/project_urs.py	(revision 4431)
@@ -0,0 +1,176 @@
+# -*- coding: cp1252 -*-
+"""Common filenames and locations for topographic data, meshes and outputs.
+Also includes origin for slump scenario.
+"""
+
+from os import sep, environ, getenv, getcwd,umask
+from os.path import expanduser, basename
+from anuga.utilities.polygon import read_polygon, plot_polygons, polygon_area, is_inside_polygon, number_mesh_triangles
+import sys
+from anuga.coordinate_transforms.redfearn import degminsec2decimal_degrees
+from time import localtime, strftime, gmtime
+from anuga.utilities.system_tools import get_user_name, get_host_name
+
+codename = 'project.py'
+
+home = getenv('INUNDATIONHOME') + sep +'data'+sep #Sandpit's parent dir   
+user = get_user_name()
+host = get_host_name()
+#needed when running using mpirun, mpirun doesn't inherit umask from .bashrc
+umask(002)
+
+
+#Making assumptions about the location of scenario data
+state = 'western_australia'
+scenario_name = 'broome'
+scenario = 'broome_tsunami_scenario_2006'
+
+#time stuff
+time = strftime('%Y%m%d_%H%M%S',gmtime()) #gets time for new dir
+build_time = time+'_build'
+run_time = time+'_run'
+
+#tide = -5.3
+#tide = 0
+tide = 4.9
+
+#Maybe will try to make project a class to allow these parameters to be passed in.
+alpha = 0.1
+friction=0.01
+starttime=3600
+finaltime=25000
+setup='final'
+
+if setup =='trial':
+    print'trial'
+    res_factor=10
+    time_thinning=48
+    yieldstep=240
+if setup =='basic': 
+    print'basic'
+    res_factor=4
+    time_thinning=12
+    yieldstep=120
+if setup =='final': 
+    print'final'
+    res_factor=1
+    time_thinning=4
+    yieldstep=60
+
+dir_comment='_'+setup+'_'+str(tide)+'_'+str(user)
+
+# onshore data from 30m DTED level 2
+onshore_name = 'Broome_topography_DLI' # original
+# offshore
+offshore_name = 'Broome_Bathymetry'
+offshore_name1 = 'inferred_north'
+offshore_name2 = 'inferred_south'
+coast_name = 'Broome_coastline'
+
+#final topo name
+combined_name ='broome_combined_elevation'
+combined_name1 ='broome_combined_elevation1'
+combined_name_unclipped1 ='broome_combined_elevation_unclipped1'
+combined_small_name = 'broome_combined_elevation_small'
+
+anuga_dir = home+state+sep+scenario+sep+'anuga'+sep
+
+topographies_in_dir = home+state+sep+scenario+sep+'elevation_final'+sep+'points'+sep+'Feb07'+sep
+topographies_dir = anuga_dir+'topographies'+sep
+
+# input topo file location
+onshore_in_dir_name = topographies_in_dir + onshore_name
+coast_in_dir_name = topographies_in_dir + coast_name
+offshore_in_dir_name = topographies_in_dir + offshore_name
+offshore_in_dir_name1 = topographies_in_dir + offshore_name1
+offshore_in_dir_name2 = topographies_in_dir + offshore_name2
+
+onshore_dir_name = topographies_dir + onshore_name
+coast_dir_name = topographies_dir + coast_name
+offshore_dir_name = topographies_dir + offshore_name
+offshore_dir_name1 = topographies_dir + offshore_name1
+offshore_dir_name2 = topographies_dir + offshore_name2
+
+#final topo files
+combined_dir_name = topographies_dir + combined_name
+combined_dir_name_unclipped1 = topographies_dir + combined_name_unclipped1
+combined_dir_name1 = topographies_dir + combined_name1
+combined_small_name_dir = topographies_dir + combined_small_name
+
+meshes_dir = anuga_dir+'meshes'+sep
+meshes_dir_name = meshes_dir + scenario_name
+
+polygons_dir = anuga_dir+'polygons'+sep
+tide_dir = anuga_dir+'tide_data'+sep
+
+#boundaries locations
+boundaries_name = 'broome_3854_17042007'
+
+boundaries_in_dir = anuga_dir+'boundaries'+sep+'urs'+sep+'1_10000'+sep
+boundaries_in_dir_name = boundaries_in_dir + boundaries_name
+boundaries_dir = anuga_dir+'boundaries'+sep
+boundaries_dir_name = boundaries_dir + boundaries_name
+
+#output locations
+output_dir = anuga_dir+'outputs'+sep
+output_build_time_dir = output_dir+build_time+sep
+output_run_time_dir = output_dir +run_time+dir_comment+sep
+output_run_time_dir_name = output_run_time_dir + scenario_name  #Used by post processing
+
+#gauges
+gauge_name = 'broome_gauges.csv'
+gauges_dir = home+sep+state+sep+scenario+sep+'anuga'+sep+'gauges'+sep
+gauges_dir_name = gauges_dir + gauge_name
+
+community_filename = gauges_dir + 'CHINS_v2.csv'
+community_broome = gauges_dir + 'community_broome.csv'
+
+#buildings_filename = gauges_dir + 'broome_res_nexis.csv'
+buildings_filename_damage_out = 'broome_res_nexis_modified.csv'
+
+###############################
+# Domain definitions
+###############################
+from anuga.utilities.polygon import read_polygon, plot_polygons, polygon_area, is_inside_polygon
+
+poly_all = read_polygon(polygons_dir+'extent_small.csv')
+#poly_all = read_polygon(polygons_dir+'extent.csv')
+res_poly_all = 150000*res_factor
+
+###############################
+# Interior region definitions
+###############################
+
+poly_0 = read_polygon(polygons_dir+'neg20_coast_contour_pts.csv')
+res_0 = 20000*res_factor
+
+poly_1 = read_polygon(polygons_dir+'broome_north_coast_inside_extent.csv')
+res_1 = 5000*res_factor
+
+poly_2 = read_polygon(polygons_dir+'broome_south_coast_inside_extent.csv')
+res_2 = 5000*res_factor
+
+poly_3 = read_polygon(polygons_dir+'Broome_town_pts.csv')
+res_3 = 2000*res_factor
+
+poly_4 = read_polygon(polygons_dir+'Broome_inner_town_pts.csv')
+res_4 = 500*res_factor
+
+interior_regions = [[poly_0,res_0],[poly_1,res_1],[poly_2,res_2]
+                     ,[poly_3,res_3],[poly_4,res_4]]
+
+trigs_min = number_mesh_triangles(interior_regions, poly_all, res_poly_all)
+
+print 'min number triangles', trigs_min
+
+poly_mainland = read_polygon(polygons_dir+'Initial_Condition.csv')
+
+###################################################################
+# Clipping regions for export to asc and regions for clipping data
+###################################################################
+
+# exporting asc grid
+e_min_area = 412000.0
+e_max_area = 423000.0
+n_min_area = 8007000.0
+n_max_area = 8022000.0
Index: /anuga_work/production/broome_2006/run_broome_urs.py
===================================================================
--- /anuga_work/production/broome_2006/run_broome_urs.py	(revision 4431)
+++ /anuga_work/production/broome_2006/run_broome_urs.py	(revision 4431)
@@ -0,0 +1,243 @@
+"""Script for running tsunami inundation scenario for Dampier, WA, Australia.
+
+Source data such as elevation and boundary data is assumed to be available in
+directories specified by project_urs.py
+The output sww file is stored in project_urs.output_run_time_dir 
+
+The scenario is defined by a triangular mesh created from project_urs.polygon,
+the elevation data and a simulated tsunami generated with URS code.
+
+Ole Nielsen and Duncan Gray, GA - 2005 and Jane Sexton, Nick Bartzis, GA - 2006
+"""
+
+#------------------------------------------------------------------------------
+# Import necessary modules
+#------------------------------------------------------------------------------
+
+# Standard modules
+from os import sep
+from os.path import dirname, basename
+from os import mkdir, access, F_OK
+from shutil import copy
+import time
+import sys
+
+# Related major packages
+from anuga.shallow_water import Domain
+from anuga.shallow_water import Dirichlet_boundary
+from anuga.shallow_water import File_boundary
+from anuga.shallow_water import Reflective_boundary
+from anuga.shallow_water import Field_boundary
+from Numeric import allclose
+
+from anuga.pmesh.mesh_interface import create_mesh_from_regions
+from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files,store_parameters
+from anuga_parallel.parallel_api import distribute, numprocs, myid, barrier
+from anuga_parallel.parallel_abstraction import get_processor_name
+from anuga.caching import myhash
+# Application specific imports
+import project_urs                 # Definition of file names and polygons
+
+def run_model(**kwargs):
+    
+    tide = kwargs['tide']
+    alpha = kwargs['alpha']
+    friction = kwargs['friction']
+    time_thinning = kwargs['time_thinning']
+    scenario_name = kwargs['aa_scenario_name']
+    
+    
+    
+    #------------------------------------------------------------------------------
+    # Copy scripts to time stamped output directory and capture screen
+    # output to file
+    #------------------------------------------------------------------------------
+
+    #copy script must be before screen_catcher
+    print 'tide',tide
+    kwargs['est_num_trigs']=project_urs.trigs_min
+    kwargs['num_cpu']=numprocs
+    kwargs['host']=project_urs.host
+    kwargs['res_factor']=project_urs.res_factor
+    kwargs['starttime']=project_urs.starttime
+    kwargs['yieldstep']=project_urs.yieldstep
+    kwargs['finaltime']=project_urs.finaltime
+    
+    kwargs['output_dir']=project_urs.output_run_time_dir
+    kwargs['bathy_file']=project_urs.combined_dir_name_unclipped1+'.txt'
+#    kwargs['bathy_file']=project_urs.combined_small_dir_name + '.pts'
+    kwargs['boundary_file']=project_urs.boundaries_dir_name + '.sww'
+
+    print 'output_dir',kwargs['output_dir']
+    if myid == 0:
+        copy_code_files(kwargs['output_dir'],__file__, 
+                 dirname(project_urs.__file__)+sep+ project_urs.__name__+'.py' )
+
+        store_parameters(**kwargs)
+
+    barrier()
+
+    start_screen_catcher(kwargs['output_dir'], myid, numprocs)
+
+    print "Processor Name:",get_processor_name()
+
+    # filenames
+#    meshes_dir_name = project_urs.meshes_dir_name+'.msh'
+
+    # creates copy of code in output dir
+    print 'min triangles', project_urs.trigs_min,
+    print 'Note: This is generally about 20% less than the final amount'
+
+    #--------------------------------------------------------------------------
+    # Create the triangular mesh based on overall clipping polygon with a
+    # tagged
+    # boundary and interior regions defined in project_urs.py along with
+    # resolutions (maximal area of per triangle) for each polygon
+    #--------------------------------------------------------------------------
+
+    #IMPORTANT don't cache create_mesh_from_region and Domain(mesh....) as it
+    # causes problems with the ability to cache set quantity which takes alot of times
+    if myid == 0:
+    
+        print 'start create mesh from regions'
+
+        create_mesh_from_regions(project_urs.poly_all,
+                         boundary_tags={'back': [1, 2], 'side': [0,3],
+                                        'ocean': [4]},
+                             maximum_triangle_area=project_urs.res_poly_all,
+                             interior_regions=project_urs.interior_regions,
+                             filename=project_urs.meshes_dir_name+'.msh',
+                             use_cache=False,
+                             verbose=True)
+    barrier()
+    
+
+    #-------------------------------------------------------------------------
+    # Setup computational domain
+    #-------------------------------------------------------------------------
+    print 'Setup computational domain'
+
+    #domain = cache(Domain, (meshes_dir_name), {'use_cache':True, 'verbose':True}, verbose=True)
+    #above don't work
+    domain = Domain(project_urs.meshes_dir_name+'.msh', use_cache=False, verbose=True)
+       
+    print domain.statistics()
+    print 'triangles',len(domain)
+    
+    kwargs['act_num_trigs']=len(domain)
+
+
+    #-------------------------------------------------------------------------
+    # Setup initial conditions
+    #-------------------------------------------------------------------------
+    if myid == 0:
+
+        print 'Setup initial conditions'
+
+        from polygon import Polygon_function
+        #following sets the stage/water to be offcoast only
+        IC = Polygon_function( [(project_urs.poly_mainland, -1.0)], default = tide,
+                                 geo_reference = domain.geo_reference)
+        domain.set_quantity('stage', IC)
+        domain.set_quantity('friction', friction) 
+        
+        print 'Start Set quantity'
+
+        domain.set_quantity('elevation', 
+                            filename = kwargs['bathy_file'],
+                            use_cache = True,
+                            verbose = True,
+                            alpha = alpha)
+        print 'Finished Set quantity'
+    barrier()
+
+
+    #------------------------------------------------------
+    # Distribute domain to implement parallelism !!!
+    #------------------------------------------------------
+
+    if numprocs > 1:
+        domain=distribute(domain)
+
+    #------------------------------------------------------
+    # Set domain parameters
+    #------------------------------------------------------
+    print 'domain id', id(domain)
+    domain.set_name(scenario_name)
+    domain.set_datadir(kwargs['output_dir'])
+    domain.set_default_order(2) # Apply second order scheme
+    domain.set_minimum_storable_height(0.01) # Don't store anything less than 1cm
+    domain.set_store_vertices_uniquely(False)
+    domain.set_quantities_to_be_stored(['stage', 'xmomentum', 'ymomentum'])
+    domain.set_maximum_allowed_speed(0.1) # Allow a little runoff (0.1 is OK)
+    print 'domain id', id(domain)
+    domain.beta_h = 0
+    #domain.limit2007 = 1
+
+    #-------------------------------------------------------------------------
+    # Setup boundary conditions 
+    #-------------------------------------------------------------------------
+    print 'Available boundary tags', domain.get_boundary_tags()
+    print 'domain id', id(domain)
+    #print 'Reading Boundary file',project_urs.boundaries_dir_namea + '.sww'
+
+    Bf = Field_boundary(kwargs['boundary_file'],
+                    domain, time_thinning=time_thinning, mean_stage=tide, 
+                    use_cache=True, verbose=True)
+                    
+    kwargs['input_start_time']=domain.starttime
+
+    print 'finished reading boundary file'
+
+    Br = Reflective_boundary(domain)
+    Bd = Dirichlet_boundary([tide,0,0])
+
+    print'set_boundary'
+
+    domain.set_boundary({'back': Br,
+                         'side': Bd,
+                         'ocean': Bf}) 
+    print'finish set boundary'
+
+    #----------------------------------------------------------------------------
+    # Evolve system through time
+    #----------------------------------------------------------------------------
+
+    t0 = time.time()
+
+    for t in domain.evolve(yieldstep = 240, finaltime = kwargs['starttime']): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')     
+
+    for t in domain.evolve(yieldstep = kwargs['yieldstep'], finaltime = 21600
+                       ,skip_initial_step = True): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')     
+    
+    for t in domain.evolve(yieldstep = 240, finaltime = kwargs['finaltime']
+                       ,skip_initial_step = True): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')   
+
+    x, y = domain.get_maximum_inundation_location()
+    q = domain.get_maximum_inundation_elevation()
+
+    print 'Maximum runup observed at (%.2f, %.2f) with elevation %.2f' %(x,y,q)
+
+    print 'That took %.2f seconds' %(time.time()-t0)
+
+    #kwargs 'completed' must be added to write the final parameters to file
+    kwargs['completed']=str(time.time()-t0)
+    store_parameters(**kwargs)
+
+
+#-------------------------------------------------------------
+if __name__ == "__main__":
+
+    run_model(file_name=project_urs.home+'detail.csv', aa_scenario_name=project_urs.scenario_name,
+              ab_time=project_urs.time, res_factor= project_urs.res_factor, tide=project_urs.tide, user=project_urs.user,
+              alpha = project_urs.alpha, friction=project_urs.friction,
+              time_thinning = project_urs.time_thinning,
+              dir_comment=project_urs.dir_comment)
+
+