Index: /anuga_work/production/pt_hedland_2006/build_pt_hedland.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/build_pt_hedland.py	(revision 4434)
+++ /anuga_work/production/pt_hedland_2006/build_pt_hedland.py	(revision 4434)
@@ -0,0 +1,139 @@
+"""Script for running tsunami inundation scenario for Dampier, WA, Australia.
+
+Source data such as elevation and boundary data is assumed to be available in
+directories specified by project_urs.py
+The output sww file is stored in project_urs.output_time_dir 
+
+The scenario is defined by a triangular mesh created from project_urs.polygon,
+the elevation data and a simulated submarine landslide.
+
+Ole Nielsen and Duncan Gray, GA - 2005 and Jane Sexton, Nick Bartzis, GA - 2006
+"""
+
+#------------------------------------------------------------------------------
+# Import necessary modules
+#------------------------------------------------------------------------------
+
+# Standard modules
+from os import sep
+from os.path import dirname, basename
+from os import mkdir, access, F_OK
+from shutil import copy
+import time
+import sys
+
+# Related major packages
+from anuga.shallow_water import Domain
+from anuga.shallow_water import Dirichlet_boundary
+from anuga.shallow_water import File_boundary
+from anuga.shallow_water import Reflective_boundary
+from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
+from anuga.pmesh.mesh_interface import create_mesh_from_regions
+from anuga.geospatial_data.geospatial_data import Geospatial_data
+from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files
+from anuga_parallel.parallel_abstraction import get_processor_name
+
+# Application specific imports
+import project_urs   # Definition of file names and polygons
+
+#------------------------------------------------------------------------------
+# Copy scripts to time stamped output directory and capture screen
+# output to file
+#------------------------------------------------------------------------------
+
+copy_code_files(project_urs.output_build_time_dir,__file__, 
+               dirname(project_urs.__file__)+sep+ project_urs.__name__+'.py' )
+
+start_screen_catcher(project_urs.output_build_time_dir)
+
+print "Processor Name:",get_processor_name()
+print 'USER: ', project_urs.user
+
+#-------------------------------------------------------------------------------
+# Preparation of topographic data
+#
+# Convert ASC 2 DEM 2 PTS using source data and store result in source data
+# Do for coarse and fine data
+# Fine pts file to be clipped to area of interest
+#-------------------------------------------------------------------------------
+print"project_urs.combined_dir_name",project_urs.combined_dir_name
+'''
+# topography directory filenames
+onshore_in_dir_name = project_urs.onshore_in_dir_name
+coast_in_dir_name = project_urs.coast_in_dir_name
+offshore_in_dir_name = project_urs.offshore_in_dir_name
+offshore1_in_dir_name = project_urs.offshore1_in_dir_name
+offshore2_in_dir_name = project_urs.offshore2_in_dir_name
+
+onshore_dir_name = project_urs.onshore_dir_name
+coast_dir_name = project_urs.coast_dir_name
+offshore_dir_name = project_urs.offshore_dir_name
+offshore1_dir_name = project_urs.offshore1_dir_name
+offshore2_dir_name = project_urs.offshore2_dir_name
+
+# creates DEM from asc data
+print "creates DEMs from asc data"
+convert_dem_from_ascii2netcdf(onshore_in_dir_name,
+                              basename_out=onshore_dir_name,
+                              use_cache=True, verbose=True)
+#creates pts file for onshore DEM
+print "creates pts file for onshore DEM"
+dem2pts(onshore_dir_name, use_cache=True, verbose=True)
+
+print'create Geospatial onshore objects from topographies'
+G = Geospatial_data(file_name = onshore_dir_name + '.pts') +\
+    Geospatial_data(file_name = coast_in_dir_name + '.txt') +\
+    Geospatial_data(file_name = offshore_in_dir_name + '.txt') 
+#    +\
+#    Geospatial_data(file_name = offshore1_dir_name + '.pts') +\
+#    Geospatial_data(file_name = offshore2_dir_name + '.pts')
+     
+
+print'clip combined geospatial object by bounding polygon'
+G_clipped = G.clip(project_urs.poly_all)
+
+print'export combined DEM file'
+if access(project_urs.topographies_dir,F_OK) == 0:
+    mkdir (project_urs.topographies_dir)
+G.export_points_file(project_urs.combined_dir_name + '.txt')
+
+print'split combined data set'
+G_small, G_other = G_clipped.split(0.1, True)
+
+print'export split DEM file'
+G_small.export_points_file(project_urs.combined_dir_name + '_small' + '.txt')
+#G_other.export_points_file(project_urs.combined_dir_name + '_other' + '.pts')
+
+'''
+print 'start reading:',project_urs.combined_dir_name + '.txt'
+G = Geospatial_data(file_name = (project_urs.combined_dir_name + '.txt'))
+G_clipped = G.clip(project_urs.poly_topo_clip)
+
+print 'start split'
+#G_smallest, G_other = G.split(0.1,True)
+
+print 'start export',project_urs.combined_smallest_dir_name + '.txt'
+#G.export_points_file(project_urs.combined_smaller_dir_name + '.txt')
+G_clipped.export_points_file(project_urs.combined_smallest_dir_name + '.txt')
+
+#-------------------------------------------------------------------------
+# Convert URS to SWW file for boundary conditions 
+#-------------------------------------------------------------------------
+print 'starting to create boundary conditions'
+#boundaries_in_dir_name = project_urs.boundaries_in_dir_name
+
+#print 'minlat=project_urs.north_boundary, maxlat=project_urs.south_boundary',project_urs.north_boundary, project_urs.south_boundary
+#print 'minlon= project_urs.west_boundary, maxlon=project_urs.east_boundary',project_urs.west_boundary, project_urs.east_boundary
+'''       
+from anuga.shallow_water.data_manager import urs_ungridded2sww
+
+print 'boundaries_in_dir_name',project_urs.boundaries_in_dir_name
+print 'project.boundaries_dir_name',project_urs.boundaries_dir_name
+
+urs_ungridded2sww(project_urs.boundaries_in_dir_name, project_urs.boundaries_dir_name,
+                  verbose=True, mint=5000, maxt=35000, zscale=1)
+'''
+
+
+
+
Index: /anuga_work/production/pt_hedland_2006/project_urs.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/project_urs.py	(revision 4434)
+++ /anuga_work/production/pt_hedland_2006/project_urs.py	(revision 4434)
@@ -0,0 +1,250 @@
+"""Common filenames and locations for topographic data, meshes and outputs.
+Also includes origin for slump scenario.
+"""
+
+from os import sep, environ, getenv, getcwd,umask
+from os.path import expanduser, basename
+from anuga.utilities.polygon import read_polygon, plot_polygons, polygon_area, is_inside_polygon, number_mesh_triangles
+import sys
+from anuga.coordinate_transforms.redfearn import degminsec2decimal_degrees
+from time import localtime, strftime, gmtime
+from anuga.utilities.system_tools import get_user_name, get_host_name
+
+codename = 'project.py'
+
+home = getenv('INUNDATIONHOME') + sep +'data'+sep #Sandpit's parent dir   
+user = get_user_name()
+host = get_host_name()
+#needed when running using mpirun, mpirun doesn't inherit umask from .bashrc
+umask(002)
+
+#Making assumptions about the location of scenario data
+state = 'western_australia'
+scenario_name = 'pt_hedland'
+scenario = 'pt_hedland_tsunami_scenario_2006'
+
+#time stuff
+time = strftime('%Y%m%d_%H%M%S',gmtime()) #gets time for new dir
+build_time = time+'_build'
+run_time = time+'_run'
+
+#tide = -3.9
+#tide = 0.0
+tide = 3.6
+
+#Maybe will try to make project a class to allow these parameters to be passed in.
+alpha = 0.1
+friction=0.01
+finaltime=25000
+starttime=3600
+setup='final'
+
+#dir_comment='_trial_'+str(tide)+'_'+str(user)
+#dir_comment='_final_'+str(tide)+'_'+str(user)
+#time_thinning=4
+#yieldstep=60
+#res_factor = 1
+
+if setup =='trial':
+    print'trial'
+    res_factor=10
+    time_thinning=48
+    yieldstep=240
+if setup =='basic': 
+    print'basic'
+    res_factor=4
+    time_thinning=12
+    yieldstep=120
+if setup =='final': 
+    print'final'
+    res_factor=1
+    time_thinning=4
+    yieldstep=60
+
+
+dir_comment='_'+setup+'_'+str(tide)+'_'+str(user)
+    
+
+
+# onshore data from 30m DTED level 2
+onshore_name = 'dli_dem' # get from Neil/Ingo (DEM or topo data)
+offshore_name = 'pt_hedland_bathy_edit'
+offshore1_name = '1'
+offshore2_name = '2'
+coast_name = 'Coastline'
+
+#final topo name
+combined_name ='pt_hedland_combined_elevation'
+combined_small_name = 'pt_hedland_combined_elevation_small'
+combined_smallest_name = 'pt_hedland_export'
+
+anuga_dir = home+state+sep+scenario+sep+'anuga'+sep
+
+topographies_in_dir = home+state+sep+scenario+sep+'elevation_final'+sep+'20070416'+sep+'points'+sep
+topographies_dir = anuga_dir+'topographies'+sep
+
+# input topo file location
+onshore_in_dir_name = topographies_in_dir + onshore_name
+coast_in_dir_name = topographies_in_dir + coast_name
+offshore_in_dir_name = topographies_in_dir + offshore_name
+offshore1_in_dir_name = topographies_in_dir + offshore1_name
+offshore2_in_dir_name = topographies_in_dir + offshore2_name
+
+onshore_dir_name = topographies_dir + onshore_name
+coast_dir_name = topographies_dir + coast_name
+offshore_dir_name = topographies_dir + offshore_name
+offshore1_dir_name = topographies_dir + offshore1_name
+offshore2_dir_name = topographies_dir + offshore2_name
+
+#final topo files
+combined_dir_name = topographies_dir + combined_name
+#combined_time_dir_name = topographies_time_dir + combined_name
+combined_small_dir_name = topographies_dir + combined_small_name
+combined_smallest_dir_name = topographies_dir + combined_smallest_name
+
+meshes_dir = anuga_dir+'meshes'+sep
+meshes_dir_name = meshes_dir + scenario_name
+
+polygons_dir = anuga_dir+'polygons'+sep
+tide_dir = anuga_dir+'tide_data'+sep
+
+#boundaries locations
+boundaries_name = 'pt_hedland_3854_17042007'
+
+boundaries_in_dir = anuga_dir+'boundaries'+sep+'urs'+sep+'1_10000'+sep
+boundaries_in_dir_name = boundaries_in_dir + boundaries_name
+boundaries_dir = anuga_dir+'boundaries'+sep
+boundaries_dir_name = boundaries_dir + boundaries_name
+
+#output locations
+output_dir = anuga_dir+'outputs'+sep
+output_build_time_dir = output_dir+build_time+sep
+output_run_time_dir = output_dir +run_time+dir_comment+sep
+output_run_time_dir_name = output_run_time_dir + scenario_name  #Used by post processing
+
+#gauges
+gauge_name = 'gauge_location_port_hedland.csv' 
+gauge_name_test = 'gauge_checking_test.csv' 
+gauges_dir = anuga_dir+'gauges'+sep
+gauges_dir_name = gauges_dir + gauge_name
+gauges_dir_name_test = gauges_dir + gauge_name_test
+
+tide_dir = anuga_dir+'tide_data'+sep
+
+buildings_filename = gauges_dir + 'pt_hedland_res.csv'
+buildings_filename_out = 'pt_hedland_res_modified.csv'
+buildings_filename_damage_out = 'pt_hedland_res_modified_damage.csv'
+tidal_filename = tide_dir + 'pt_hedland_tide.txt'
+community_filename = gauges_dir + 'CHINS_v2.csv'
+community_scenario = gauges_dir + 'community_pt_hedland.csv'
+
+# clipping region to make DEM (pts file) from onshore data
+eastingmin = 594000
+eastingmax = 715000
+northingmin = 7720000
+northingmax = 7880000
+
+# for ferret2sww
+south = degminsec2decimal_degrees(-20,30,0)
+north = degminsec2decimal_degrees(-17,10,0)
+west = degminsec2decimal_degrees(117,00,0)
+east = degminsec2decimal_degrees(120,00,0)
+
+# region to export (used from export_results.py)
+e_min_area = 648000
+e_max_area = 675000
+n_min_area = 7745000
+n_max_area = 7761000
+
+export_region = [[e_min_area,n_min_area],[e_min_area,n_max_area],
+                 [e_max_area,n_max_area],[e_max_area,n_min_area]]
+                 
+refzone = 50 
+
+from anuga.coordinate_transforms.redfearn import redfearn
+# boundary up to 50 m contour
+lat1_50 = degminsec2decimal_degrees(-19,20,0)
+lat2_50 = degminsec2decimal_degrees(-19,30,0)
+lat3_50 = degminsec2decimal_degrees(-19,45,0)
+lon1_50 = degminsec2decimal_degrees(119,05,0)
+lon2_50 = degminsec2decimal_degrees(118,20,0)
+lon3_50 = degminsec2decimal_degrees(117,45,0)
+z, easting, northing = redfearn(lat1_50, lon1_50)
+d0_50 = [easting, northing]
+z, easting, northing = redfearn(lat2_50, lon2_50)
+d1_50 = [easting, northing]
+z, easting, northing= redfearn(lat3_50, lon3_50)
+d2_50 = [easting, northing]
+
+d4_50 = [285000, 7585000]
+d6_50 = [330000, 7605000]
+#bounding_poly50 = [p0_50, p1_50, p2_50, d6_50, d5, d4_50]
+
+d0 = [763852.0, 7934358.0]
+d1 = [710987.0, 7925797.0]
+d2 = [658264.0, 7926314.0]
+d3 = [552686.0, 7871580.0]
+#d4 = [604415.81, 7733013.56]
+d4 = [638000.0, 7733013.56]
+#d5 = [656561.15, 7732615.11]
+d5 = [662000.0, 7732615.11]
+#d6 = [708940.32, 7750510.33]
+d6 = [690000.0, 7740510.33]
+#polyAll = [d0, d1, d2, d3, d4, d5, d6]
+#polyAll = [d0_50, d1_50, d2_50, d4, d5, d6]
+# from Hamish
+h0=[629262.17, 7747205.47]
+h1=[552686.00, 7871579.99] #d3
+h2=[658264.00, 7926314.00] #d2
+h3=[710986.99, 7925796.99] #d1
+h4=[763851.99, 7934357.99] #d0
+h5=[701485.21, 7770656.86]
+h6=[698273.75, 7762227.38]
+h7=[698194.23, 7762018.65]
+h8=[691627.41, 7744781.98]
+h9=[679220.75, 7743604.59]
+h10=[653512.59, 7740528.56]
+h11=[634777.71, 7738247.17]
+h12=[629443.86, 7746910.37]
+h13=[629396.84, 7746986.75]
+h14=[629352.32, 7747059.06]
+h15=[629276.24, 7747182.63]
+h16=[629262.17, 7747205.47] #repeat of h0
+# using Hamish's new bounding polygon
+#polyAll = [d0_50, d1_50, d2_50, h16,h15,h14,h13,h12,h11,h10,h9,h8,h7,h6,h5]
+poly_all = [d0_50, d1_50, d2_50, h16,h11,h8,h6, h5]
+res_poly_all = 250000*res_factor
+
+#Interior region - Pt Hedland town
+i0 = [668000, 7757000]
+i1 = [659000, 7755000]
+i2 = [660000, 7749000]
+i3 = [667000, 7746000]
+i4 = [678000, 7751000]
+
+poly_pt_hedland = [i0, i1, i2, i3, i4]
+res_pt_hedland=500*res_factor
+
+#Are there other significant features?
+j0 = [670000, 7760000]
+j1 = [633000, 7745000]
+j2 = [665000, 7743000]
+j3 = [690000, 7755000]
+
+poly_region = [j0, j1, j2, j3]
+res_region = 50000*res_factor
+
+poly_mainland = read_polygon(polygons_dir+'Initial_Condition.csv')
+
+poly_topo_clip = [[664000,7752000],[664000,7754000],
+                  [666000,7754000],[666000,7752000]]
+
+interior_regions = [[poly_pt_hedland,res_pt_hedland],[poly_region,res_region]
+#                    ,[poly_region,res_region]
+                    ]
+
+trigs_min = number_mesh_triangles(interior_regions, poly_all, res_poly_all)
+
+print 'min number triangles', trigs_min
+
+
Index: /anuga_work/production/pt_hedland_2006/run_boundary_points.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/run_boundary_points.py	(revision 4434)
+++ /anuga_work/production/pt_hedland_2006/run_boundary_points.py	(revision 4434)
@@ -0,0 +1,35 @@
+"""Script for running tsunami inundation scenario for Dampier, WA, Australia.
+
+Source data such as elevation and boundary data is assumed to be available in
+directories specified by project.py
+The output sww file is stored in project.output_run_time_dir 
+
+The scenario is defined by a triangular mesh created from project.polygon,
+the elevation data and a simulated tsunami generated with URS code.
+
+Ole Nielsen and Duncan Gray, GA - 2005 and Jane Sexton, Nick Bartzis, GA - 2006
+"""
+
+#------------------------------------------------------------------------------
+# Import necessary modules
+#------------------------------------------------------------------------------
+
+# Standard modules
+
+# # Related major packages
+# from anuga.shallow_water import Domain
+from anuga.shallow_water.data_manager import URS_points_needed_to_file, \
+     urs_ungridded2sww
+import project                 # Definition of file names and polygons
+
+#------------------------------------------------------------------------------
+# Copy scripts to time stamped output directory and capture screen
+# output to file
+#------------------------------------------------------------------------------
+poly = project.polyAll
+print "poly", poly
+print "project.boundaries",project.boundarydir
+URS_points_needed_to_file(project.boundarydir,poly, export_csv=True, zone=50)
+#URS_points_needed_to_file(project.boundaries_dir_name5,poly, export_csv=True, zone=50)
+#URS_points_needed_to_file(project.boundaries_dir_name5,poly, export_csv=True)
+#urs_ungridded2sww(project.boundaries_in_dir_name2, project.boundaries_dir_name5, mean_stage= project.tide,  verbose=True)
Index: /anuga_work/production/pt_hedland_2006/run_pt_hedland_urs.py
===================================================================
--- /anuga_work/production/pt_hedland_2006/run_pt_hedland_urs.py	(revision 4434)
+++ /anuga_work/production/pt_hedland_2006/run_pt_hedland_urs.py	(revision 4434)
@@ -0,0 +1,235 @@
+"""Script for running tsunami inundation scenario for Dampier, WA, Australia.
+
+Source data such as elevation and boundary data is assumed to be available in
+directories specified by project_urs.py
+The output sww file is stored in project_urs.output_run_time_dir 
+
+The scenario is defined by a triangular mesh created from project_urs.polygon,
+the elevation data and a simulated tsunami generated with URS code.
+
+Ole Nielsen and Duncan Gray, GA - 2005 and Jane Sexton, Nick Bartzis, GA - 2006
+"""
+
+#------------------------------------------------------------------------------
+# Import necessary modules
+#------------------------------------------------------------------------------
+
+# Standard modules
+from os import sep,umask
+from os.path import dirname, basename
+from os import mkdir, access, F_OK
+from shutil import copy
+import time
+import sys
+
+# Related major packages
+from anuga.shallow_water import Domain
+from anuga.shallow_water import Dirichlet_boundary
+from anuga.shallow_water import File_boundary
+from anuga.shallow_water import Reflective_boundary
+from anuga.shallow_water import Field_boundary
+from Numeric import allclose
+
+from anuga.pmesh.mesh_interface import create_mesh_from_regions
+from anuga.abstract_2d_finite_volumes.util import start_screen_catcher, copy_code_files,store_parameters
+from anuga_parallel.parallel_api import distribute, numprocs, myid, barrier
+from anuga_parallel.parallel_abstraction import get_processor_name
+from anuga.caching import myhash
+# Application specific imports
+import project_urs                 # Definition of file names and polygons
+
+def run_model(**kwargs):
+    
+    tide = kwargs['tide']
+    alpha = kwargs['alpha']
+    friction = kwargs['friction']
+    time_thinning = kwargs['time_thinning']
+    scenario_name = kwargs['aa_scenario_name']
+    
+    #------------------------------------------------------------------------------
+    # Copy scripts to time stamped output directory and capture screen
+    # output to file
+    #------------------------------------------------------------------------------
+
+    #copy script must be before screen_catcher
+    print 'tide',tide
+    kwargs['est_num_trigs']=project_urs.trigs_min
+    kwargs['num_cpu']=numprocs
+    kwargs['host']=project_urs.host
+    kwargs['res_factor']=project_urs.res_factor
+    kwargs['starttime']=project_urs.starttime
+    kwargs['yieldstep']=project_urs.yieldstep
+    kwargs['finaltime']=project_urs.finaltime
+    
+    kwargs['output_dir']=project_urs.output_run_time_dir
+    kwargs['bathy_file']=project_urs.combined_dir_name + '.txt'
+#    kwargs['bathy_file']=project_urs.combined_small_dir_name + '.pts'
+    kwargs['boundary_file']=project_urs.boundaries_dir_name + '.sww'
+#    kwargs['Completed']=''
+
+    print 'output_dir',kwargs['output_dir']
+    if myid == 0:
+        copy_code_files(kwargs['output_dir'],__file__, 
+                 dirname(project_urs.__file__)+sep+ project_urs.__name__+'.py' )
+
+        store_parameters(**kwargs)
+
+    barrier()
+
+    start_screen_catcher(kwargs['output_dir'], myid, numprocs)
+
+    print "Processor Name:",get_processor_name()
+
+    # creates copy of code in output dir
+    print 'min triangles', project_urs.trigs_min,
+    print 'Note: This is generally about 20% less than the final amount'
+
+    #--------------------------------------------------------------------------
+    # Create the triangular mesh based on overall clipping polygon with a
+    # tagged
+    # boundary and interior regions defined in project_urs.py along with
+    # resolutions (maximal area of per triangle) for each polygon
+    #--------------------------------------------------------------------------
+
+    #IMPORTANT don't cache create_mesh_from_region and Domain(mesh....) as it
+    # causes problems with the ability to cache set quantity which takes alot of times
+    if myid == 0:
+    
+        print 'start create mesh from regions'
+
+        create_mesh_from_regions(project_urs.poly_all,
+                             boundary_tags={'back': [3, 4, 5, 6], 'side': [2, 7],
+                                            'ocean': [0, 1]},
+                             maximum_triangle_area=project_urs.res_poly_all,
+                             interior_regions=project_urs.interior_regions,
+                             filename=project_urs.meshes_dir_name+'.msh',
+                             use_cache=False,
+                             verbose=True)
+    barrier()
+
+    #-------------------------------------------------------------------------
+    # Setup computational domain
+    #-------------------------------------------------------------------------
+    print 'Setup computational domain'
+
+    #domain = cache(Domain, (meshes_dir_name), {'use_cache':True, 'verbose':True}, verbose=True)
+    #above don't work
+    domain = Domain(project_urs.meshes_dir_name+'.msh', use_cache=False, verbose=True)
+       
+    print domain.statistics()
+    print 'triangles',len(domain)
+    
+    kwargs['act_num_trigs']=len(domain)
+
+    #-------------------------------------------------------------------------
+    # Setup initial conditions
+    #-------------------------------------------------------------------------
+    if myid == 0:
+
+        print 'Setup initial conditions'
+
+        from polygon import Polygon_function
+        #following sets the stage/water to be offcoast only
+        IC = Polygon_function( [(project_urs.poly_mainland, -1.0)], default = tide,
+                                 geo_reference = domain.geo_reference)
+        domain.set_quantity('stage', IC)
+        domain.set_quantity('friction', friction) 
+        
+        print 'Start Set quantity'
+
+        domain.set_quantity('elevation', 
+                            filename = kwargs['bathy_file'],
+                            use_cache = True,
+                            verbose = True,
+                            alpha = alpha)
+        print 'Finished Set quantity'
+    barrier()
+
+    #------------------------------------------------------
+    # Distribute domain to implement parallelism !!!
+    #------------------------------------------------------
+
+    if numprocs > 1:
+        domain=distribute(domain)
+
+    #------------------------------------------------------
+    # Set domain parameters
+    #------------------------------------------------------
+    print 'domain id', id(domain)
+    domain.set_name(scenario_name)
+    domain.set_datadir(kwargs['output_dir'])
+    domain.set_default_order(2) # Apply second order scheme
+    domain.set_minimum_storable_height(0.01) # Don't store anything less than 1cm
+    domain.set_store_vertices_uniquely(False)
+    domain.set_quantities_to_be_stored(['stage', 'xmomentum', 'ymomentum'])
+    domain.set_maximum_allowed_speed(0.1) # Allow a little runoff (0.1 is OK)
+    print 'domain id', id(domain)
+    domain.beta_h = 0
+    #domain.limit2007 = 1
+
+    #-------------------------------------------------------------------------
+    # Setup boundary conditions 
+    #-------------------------------------------------------------------------
+    print 'Available boundary tags', domain.get_boundary_tags()
+    print 'domain id', id(domain)
+    #print 'Reading Boundary file',project_urs.boundaries_dir_namea + '.sww'
+
+    Bf = Field_boundary(kwargs['boundary_file'],
+                    domain, time_thinning=time_thinning, mean_stage=tide, 
+                    use_cache=True, verbose=True)
+                    
+    kwargs['input_start_time']=domain.starttime
+
+    print 'finished reading boundary file'
+
+    Br = Reflective_boundary(domain)
+    Bd = Dirichlet_boundary([tide,0,0])
+
+    print'set_boundary'
+
+    domain.set_boundary({'back': Br,
+                         'side': Bd,
+                         'ocean': Bf}) 
+    print'finish set boundary'
+
+    #----------------------------------------------------------------------------
+    # Evolve system through time
+    #----------------------------------------------------------------------------
+
+    t0 = time.time()
+
+    for t in domain.evolve(yieldstep = 240, finaltime = kwargs['starttime']): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')     
+
+    for t in domain.evolve(yieldstep = kwargs['yieldstep'], finaltime = 21600
+                       ,skip_initial_step = True): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')     
+    
+    for t in domain.evolve(yieldstep = 240, finaltime = kwargs['finaltime']
+                       ,skip_initial_step = True): 
+        domain.write_time()
+        domain.write_boundary_statistics(tags = 'ocean')   
+
+    x, y = domain.get_maximum_inundation_location()
+    q = domain.get_maximum_inundation_elevation()
+
+    print 'Maximum runup observed at (%.2f, %.2f) with elevation %.2f' %(x,y,q)
+
+    print 'That took %.2f seconds' %(time.time()-t0)
+    
+    kwargs['completed']=str(time.time()-t0)
+    
+    store_parameters(**kwargs)
+
+#-------------------------------------------------------------
+if __name__ == "__main__":
+
+    run_model(file_name=project_urs.home+'detail.csv', aa_scenario_name=project_urs.scenario_name,
+              ab_time=project_urs.time, res_factor= project_urs.res_factor, tide=project_urs.tide, user=project_urs.user,
+              alpha = project_urs.alpha, friction=project_urs.friction,
+              time_thinning = project_urs.time_thinning,
+              dir_comment=project_urs.dir_comment)
+
+